> For the complete documentation index, see [llms.txt](https://docs.trace.market/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.trace.market/readme/our-peer-to-peer-advantages.md).

# Our Peer-to-Peer Advantages

If all stakeholders state mainly what they have direct knowledge (and proof) about, then misinformation and pointing fingers at each other can be prevented.

As things evolve, these information chunks reference each other, so the right information can still be always available, with improved accuracy.

This shared knowledge graph should be stored on a [decentralized infrastructure](https://www.ethswarm.org/), because

1. should be available to every stakeholder, to be used as the Single Source of Truth, therefore keep it updated
   1. at the same time, we provide unrivalled privacy for encrypted attributes: you can set conditions who should be able to decrypt (like current owners or license holders)
2. nobody should be able to censor or delete it
   1. ..not even "system admins" or shareholders of the provider
   2. once uploaded, our data is available as long as its "postage stamp" is funded
3. nobody should be able to manipulate it
   1. even adding a space or modifying any character alters its *keccak* hash, which is used for retrieval
4. and of course, protection from electromagnetic pulses, physical damages, single point of failure, hacking attacks, etc.

## Trustless? Sure, you can verify!

### Is the uploaded data unaltered?

On DevTools' Network tab, check the underlying API call's Response. Use its `swarmReference` attribute to match the data in any Swarm Gateway (an *official* is <https://gateway.ethswarm.org/access> ).

### Are the right attributes linked to my NFT listing?

Check in a block explorer, like the open-source [Blockscout](https://gnosis-chiado.blockscout.com/token/0x1162813F9e8946196f3302E33D485F4f81e970e6). Find the minting transaction, check *swarmHash* (arg 2) in its input data. [Convert that uint32 to hex/Bytes32 format](https://uint256.net/docs/converter), copy it after 0x and use for retrieval from any Swarm Gateway.

### Are the right attributes loaded into our insights?

Combine the above methods! On DevTools' Network tab, compare what we GET from our Swarm node with the *tokenId* and *swarmHash* on a Blockchain explorer.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.trace.market/readme/our-peer-to-peer-advantages.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
